/// <reference types="sequelize" />
import * as Sequelize from 'sequelize';
import { SpecType } from 'pretur.spec';
import { Query, MutateRequest } from 'pretur.sync';
import { ResolveResult } from './resolver';
import { ModelDescriptor } from './descriptor';
import { ResultItemAppender } from './synchronizer';
export declare type Transaction = Sequelize.Transaction;
export interface ModelDescriptorMap {
    [model: string]: ModelDescriptor<any>;
}
export interface Pool {
    models: ModelDescriptorMap;
    resolve<T extends SpecType>(query: Query<T>, context: any): Promise<ResolveResult<T>>;
    sync<T extends SpecType>(transaction: Transaction, item: MutateRequest<T>, rip: ResultItemAppender, context: any): Promise<Partial<T['fields']> | void>;
}
export declare function createPool(...descriptors: ModelDescriptor<any>[]): Pool;
