import { Query } from 'pretur.sync';
import { Spec, SpecType, Model } from 'pretur.spec';
import { Pool } from './pool';
export interface ResolveResult<T extends SpecType> {
    data: Partial<Model<T>>[];
    count?: number;
}
export interface Resolver<T extends SpecType> {
    (query?: Partial<Query<T>>, context?: any): Promise<ResolveResult<T>>;
}
export interface CustomResolver<T extends SpecType> {
    (query: Query<T> | undefined, pool: Pool, context: any): Promise<ResolveResult<T>>;
}
export interface UnitializedResolver<T extends SpecType> {
    resolver: Resolver<T>;
    initialize(pool: Pool): void;
}
export interface ResolveInterceptor<T extends SpecType> {
    (query: Query<T> | undefined, result: ResolveResult<T>, context: any): Promise<ResolveResult<T>>;
}
export interface BuildResolverOptions<T extends SpecType> {
    intercept?: ResolveInterceptor<T>;
    queryTransformer?(query: Query<T> | undefined): Query<T> | undefined;
}
export declare function buildCustomResolver<T extends SpecType>(_: Spec<T>, resolver: CustomResolver<T>): UnitializedResolver<T>;
export declare function buildResolver<T extends SpecType>(spec: Spec<T>, options?: BuildResolverOptions<T>): UnitializedResolver<T>;
