/// <reference types="sequelize" />
import * as Sequelize from 'sequelize';
import { Pool } from './pool';
import { Spec, SpecType, Model } from 'pretur.spec';
export declare type SequelizeInstance<T extends SpecType> = Sequelize.Instance<Partial<Model<T>>> & Partial<Model<T>>;
export declare type SequelizeModel<T extends SpecType> = Sequelize.Model<SequelizeInstance<T>, Partial<Model<T>>>;
export interface UninitializedSequelizeModel<T extends SpecType> {
    sequelizeModel: SequelizeModel<T>;
    initialize(pool: Pool): void;
}
export interface BuildSequelizeModelOptions<T extends SpecType> {
    attributeToFieldMap?: {
        [P in keyof T['fields']]?: string;
    };
    tableName?: string;
    createDatabase?(sequelizeModel: SequelizeModel<T>): void;
}
export declare function buildSequelizeModel<T extends SpecType>(spec: Spec<T>, sequelize: Sequelize.Sequelize, options?: BuildSequelizeModelOptions<T>): UninitializedSequelizeModel<T>;
